#include <stdio.h>
#include <stdlib.h>

#include "Pilha.h"

void inicializar(Pilha *p)
{
  p->topo = -1;
}

void empilhar(Pilha *p, Tipo v)
{
  if (cheia(p))
  {
    printf("Pilha cheia!\n");
  }
  else
  {
    ++p->topo;
    p->vetor[p->topo] = v;
  }
}

Tipo desempilhar(Pilha *p)
{
  if (vazia(p))
  {
    printf("Pilha vazia!\n");
    exit(1);
  }
  else
  {
    --p->topo;
    return p->vetor[p->topo+1];
  }
}

Tipo topo(Pilha *p)
{
  if (vazia(p))
  {
    printf("Pilha vazia!\n");
    exit(1);
  }
  else
  {
    return p->vetor[p->topo];
  }
}

int vazia(Pilha *p)
{
  return p->topo == -1;
}

int cheia(Pilha *p)
{
  return p->topo == TAM - 1;
}

void imprimir(Pilha *p)
{
  int i;
  printf("{");
  for (i = 0; i <= p->topo; ++i)
    printf("%c ", p->vetor[i]);
  printf("}\n");
}
